package b4j.SpectrumGraph;


import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.debug.*;

public class main extends javafx.application.Application{
public static main mostCurrent = new main();

public static BA ba;
static {
		ba = new  anywheresoftware.b4j.objects.FxBA("b4j.SpectrumGraph", "b4j.SpectrumGraph.main", null);
		ba.loadHtSubs(main.class);
        if (ba.getClass().getName().endsWith("ShellBA")) {
			
			ba.raiseEvent2(null, true, "SHELL", false);
			ba.raiseEvent2(null, true, "CREATE", true, "b4j.SpectrumGraph.main", ba);
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}

 
    public static void main(String[] args) {
    	launch(args);
    }
    public void start (javafx.stage.Stage stage) {
        try {
            if (!false)
                System.setProperty("prism.lcdtext", "false");
            anywheresoftware.b4j.objects.FxBA.application = this;
		    anywheresoftware.b4a.keywords.Common.setDensity(javafx.stage.Screen.getPrimary().getDpi());
            anywheresoftware.b4a.keywords.Common.LogDebug("Program started.");
            initializeProcessGlobals();
            anywheresoftware.b4j.objects.Form frm = new anywheresoftware.b4j.objects.Form();
            frm.initWithStage(ba, stage, 600, 400);
            ba.raiseEvent(null, "appstart", frm, (String[])getParameters().getRaw().toArray(new String[0]));
        } catch (Throwable t) {
            BA.printException(t, true);
            System.exit(1);
        }
    }
public static anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4j.objects.JFX _fx = null;
public static anywheresoftware.b4j.objects.Form _mainform = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static int _x0 = 0;
public static int _x1 = 0;
public static int _y0 = 0;
public static int _y1 = 0;
public static int _dx = 0;
public static int _dy = 0;
public static anywheresoftware.b4a.objects.PanelWrapper _pnlgraph = null;
public static anywheresoftware.b4a.objects.drawable.CanvasWrapper _cvsgraph = null;
public static anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rectmovesource = null;
public static anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rectmovedest = null;
public static String  _appstart(anywheresoftware.b4j.objects.Form _form1,String[] _args) throws Exception{
 //BA.debugLineNum = 18;BA.debugLine="Sub AppStart (Form1 As Form, Args() As String)";
 //BA.debugLineNum = 19;BA.debugLine="MainForm = Form1";
_mainform = _form1;
 //BA.debugLineNum = 21;BA.debugLine="MainForm.Show";
_mainform.Show();
 //BA.debugLineNum = 23;BA.debugLine="cvsGraph.Initialize(pnlGraph)";
_cvsgraph.Initialize((android.view.View)(_pnlgraph.getObject()));
 //BA.debugLineNum = 25;BA.debugLine="InitGraph";
_initgraph();
 //BA.debugLineNum = 27;BA.debugLine="Timer1.Initialize(\"Timer1\", 1000)";
_timer1.Initialize(ba,"Timer1",(long) (1000));
 //BA.debugLineNum = 28;BA.debugLine="Timer1.Enabled = True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 30;BA.debugLine="DrawRow";
_drawrow();
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _drawrow() throws Exception{
int _col = 0;
int _x = 0;
int _y = 0;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rct = null;
 //BA.debugLineNum = 47;BA.debugLine="Private Sub DrawRow";
 //BA.debugLineNum = 48;BA.debugLine="Private col, x, y As Int";
_col = 0;
_x = 0;
_y = 0;
 //BA.debugLineNum = 49;BA.debugLine="Private rct As Rect";
_rct = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 51;BA.debugLine="For col = 0 To 255";
{
final int step3 = 1;
final int limit3 = (int) (255);
for (_col = (int) (0) ; (step3 > 0 && _col <= limit3) || (step3 < 0 && _col >= limit3); _col = ((int)(0 + _col + step3)) ) {
 //BA.debugLineNum = 52;BA.debugLine="x = x0 + col * dx";
_x = (int) (_x0+_col*_dx);
 //BA.debugLineNum = 53;BA.debugLine="y = y0 - dy";
_y = (int) (_y0-_dy);
 //BA.debugLineNum = 54;BA.debugLine="rct.Initialize(x, y, x + dx, y0)";
_rct.Initialize(_x,_y,(int) (_x+_dx),_y0);
 //BA.debugLineNum = 55;BA.debugLine="cvsGraph.DrawRect(rct, Colors.RGB(Rnd(0, 256), R";
_cvsgraph.DrawRect((android.graphics.Rect)(_rct.getObject()),anywheresoftware.b4a.keywords.Common.Colors.RGB(anywheresoftware.b4a.keywords.Common.Rnd((int) (0),(int) (256)),anywheresoftware.b4a.keywords.Common.Rnd((int) (0),(int) (256)),anywheresoftware.b4a.keywords.Common.Rnd((int) (0),(int) (256))),anywheresoftware.b4a.keywords.Common.True,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 }
};
 //BA.debugLineNum = 57;BA.debugLine="pnlGraph.Invalidate";
_pnlgraph.Invalidate();
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static String  _initgraph() throws Exception{
 //BA.debugLineNum = 34;BA.debugLine="Private Sub InitGraph";
 //BA.debugLineNum = 35;BA.debugLine="dx = (pnlGraph.Width - 40dip) / 256";
_dx = (int) ((_pnlgraph.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)))/(double)256);
 //BA.debugLineNum = 36;BA.debugLine="x0 = (pnlGraph.Width - 256 * dx) / 1.8";
_x0 = (int) ((_pnlgraph.getWidth()-256*_dx)/(double)1.8);
 //BA.debugLineNum = 37;BA.debugLine="x1 = x0 + 256 * dx";
_x1 = (int) (_x0+256*_dx);
 //BA.debugLineNum = 38;BA.debugLine="dy = (pnlGraph.Height - 40dip) / 60";
_dy = (int) ((_pnlgraph.getHeight()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (40)))/(double)60);
 //BA.debugLineNum = 39;BA.debugLine="y0 = pnlGraph.Height - (pnlGraph.Height - 60 * dy";
_y0 = (int) (_pnlgraph.getHeight()-(_pnlgraph.getHeight()-60*_dy)/(double)1.8);
 //BA.debugLineNum = 40;BA.debugLine="y1 = y0 - 60 * dy";
_y1 = (int) (_y0-60*_dy);
 //BA.debugLineNum = 41;BA.debugLine="cvsGraph.DrawLine(x0 - 4dip, y0, x1 + 6dip , y0,";
_cvsgraph.DrawLine((float) (_x0-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))),(float) (_y0),(float) (_x1+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (6))),(float) (_y0),anywheresoftware.b4a.keywords.Common.Colors.Black,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 //BA.debugLineNum = 42;BA.debugLine="cvsGraph.DrawLine(x0, y0 + 4dip, x0 , y1 - 6dip,";
_cvsgraph.DrawLine((float) (_x0),(float) (_y0+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (4))),(float) (_x0),(float) (_y1-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (6))),anywheresoftware.b4a.keywords.Common.Colors.Black,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 //BA.debugLineNum = 43;BA.debugLine="rectMoveSource.Initialize(x0, y0 - 59 * dy, x1, y";
_rectmovesource.Initialize(_x0,(int) (_y0-59*_dy),_x1,_y0);
 //BA.debugLineNum = 44;BA.debugLine="rectMoveDest.Initialize(x0, y1, x1, y0 - dy)";
_rectmovedest.Initialize(_x0,_y1,_x1,(int) (_y0-_dy));
 //BA.debugLineNum = 45;BA.debugLine="End Sub";
return "";
}
public static String  _moverows() throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Private Sub MoveRows";
 //BA.debugLineNum = 61;BA.debugLine="cvsGraph.DrawBitmap(cvsGraph.Bitmap, rectMoveSour";
_cvsgraph.DrawBitmap((android.graphics.Bitmap)(_cvsgraph.getBitmap().getObject()),(android.graphics.Rect)(_rectmovesource.getObject()),(android.graphics.Rect)(_rectmovedest.getObject()));
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}

private static boolean processGlobalsRun;
public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 7;BA.debugLine="Private fx As JFX";
_fx = new anywheresoftware.b4j.objects.JFX();
 //BA.debugLineNum = 8;BA.debugLine="Private MainForm As Form";
_mainform = new anywheresoftware.b4j.objects.Form();
 //BA.debugLineNum = 9;BA.debugLine="Public Timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 10;BA.debugLine="Public x0, x1, y0, y1, dx, dy As Int";
_x0 = 0;
_x1 = 0;
_y0 = 0;
_y1 = 0;
_dx = 0;
_dy = 0;
 //BA.debugLineNum = 12;BA.debugLine="Private pnlGraph As Panel";
_pnlgraph = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 13;BA.debugLine="Private cvsGraph As Canvas";
_cvsgraph = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 14;BA.debugLine="Private rectMoveSource, rectMoveDest As Rect";
_rectmovesource = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
_rectmovedest = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return "";
}
public static String  _timer1_tick() throws Exception{
 //BA.debugLineNum = 64;BA.debugLine="Private Sub Timer1_Tick";
 //BA.debugLineNum = 65;BA.debugLine="MoveRows";
_moverows();
 //BA.debugLineNum = 66;BA.debugLine="DrawRow";
_drawrow();
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}
}
